-- Config

local O = Apollo.GetAddon("Odyssey")
local DaiGUI = Apollo.GetPackage("DaiGUI-1.0").tPackage

local L = O.l

function O.ConfigInit()
  local window = O.configWindow

  if not window then
    O.configWindow = { visible = false }
    window = O.configWindow
    
    window.base = Apollo.LoadForm(O.xmlMainDoc, "ConfigForm", nil, O)
    local anchors = {window.base:GetAnchorOffsets()}
    window.base:SetAnchorOffsets(
    (Apollo.GetDisplaySize().nWidth - 350) / 2,
    (Apollo.GetDisplaySize().nHeight - 280) / 2,
    (Apollo.GetDisplaySize().nWidth - 350) / 2 + anchors[3],
    (Apollo.GetDisplaySize().nHeight - 280) / 2 + anchors[4])

    window.header = window.base:FindChild("Header")
    window.header:SetBGColor(O.settings.backgroundColor)

    window.opacity = window.base:FindChild("OpacityBackground")
    window.opacity:SetOpacity(0.8)
    window.opacity:SetBGColor(O.settings.backgroundColor)
    
    window.tabs = {}
    window.tabs[1] = window.base:FindChild("TabList:Tab1:TabBackground")
    window.tabs[2] = window.base:FindChild("TabList:Tab2:TabBackground")
    window.tabs[3] = window.base:FindChild("TabList:Tab3:TabBackground")
    window.currenttab = 1
    
    window.tabwindows = {}
    window.tabwindows[1] = window.base:FindChild("TabWindow1")
    window.tabwindows[2] = window.base:FindChild("TabWindow2")
    window.tabwindows[3] = window.base:FindChild("TabWindow3")

    window.tabwindows[window.currenttab]:Show(true)
    window.tabs[window.currenttab]:SetOpacity(0.9)
    window.tabs[window.currenttab]:SetBGColor(O.settings.backgroundColor)

    for i = 2, #window.tabs do
      window.tabs[i]:SetOpacity(0.2)
      window.tabs[i]:SetBGColor(O.settings.backgroundColor)
      window.tabwindows[i]:Show(false)
    end
    
    -- Tab 1
    window.lockbutton = window.base:FindChild("LockButton")
    window.tooltipsbutton = window.base:FindChild("TooltipsButton")
    window.selfbutton = window.base:FindChild("SelfButton")
    window.onlybossbutton = window.base:FindChild("OnlyBossButton")
    window.showfootercurrentbutton = window.base:FindChild("ShowFooterCurrentTotalButton")
    window.showfooteroverallbutton = window.base:FindChild("ShowFooterOverallTotalButton")
    window.showseparatepetsbutton = window.base:FindChild("ShowSeparatePetsButton")
    window.hideduringcombatbutton = window.base:FindChild("HideDuringCombatButton")
    window.showgatheringnodesbutton = window.base:FindChild("ShowGatheringNodesButton")

    window.endcombatdelayslider = window.base:FindChild("EndCombatDelaySlider")
    window.endcombatdelayslider:SetValue(O.settings.combat_timeout)
    window.endcombatdelaytext = window.base:FindChild("EndCombatDelayValue")
    window.endcombatdelaytext:SetText(O.settings.combat_timeout)

    -- Tab 2
    window.bg_opacityslider = window.base:FindChild("BG_TransparencySlider")
    window.bg_opacityslider:SetValue(O.settings.bg_opacity * 10)
    window.bg_opacitytext = window.base:FindChild("BG_TransparencyValue")
    window.bg_opacitytext:SetText(O.settings.bg_opacity)

    window.mg_opacityslider = window.base:FindChild("MG_TransparencySlider")
    window.mg_opacityslider:SetValue(O.settings.mg_opacity * 10)
    window.mg_opacitytext = window.base:FindChild("MG_TransparencyValue")
    window.mg_opacitytext:SetText(O.settings.mg_opacity)

    window.bar_opacityslider = window.base:FindChild("Bar_TransparencySlider")
    window.bar_opacityslider:SetValue(O.settings.bar_opacity * 10)
    window.bar_opacitytext = window.base:FindChild("Bar_TransparencyValue")
    window.bar_opacitytext:SetText(O.settings.bar_opacity)

    window.fg_opacityslider = window.base:FindChild("FG_TransparencySlider")
    window.fg_opacityslider:SetValue(O.settings.fg_opacity * 10)
    window.fg_opacitytext = window.base:FindChild("FG_TransparencyValue")
    window.fg_opacitytext:SetText(O.settings.fg_opacity)

    window.percentbutton = window.base:FindChild("ShowPercentButton")
    window.absbutton = window.base:FindChild("ShowAbsButton")
    window.rankbutton = window.base:FindChild("ShowRankButton")
    window.shortbutton = window.base:FindChild("ShowShortButton")
    window.showbattletotalbutton = window.base:FindChild("ShowPerBattleTotalButton")
    --window.showhistorytotalbutton = window.base:FindChild("ShowHistoryTotalButton")

    -- Tab 3
    local tmp_color = {}
    window.classcolors = {}
    window.classcolors[GameLib.CodeEnumClass.Warrior] = window.base:FindChild("TabWindow3:WarriorColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Warrior]
    window.classcolors[GameLib.CodeEnumClass.Warrior]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.classcolors[GameLib.CodeEnumClass.Engineer] = window.base:FindChild("TabWindow3:EngineerColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Engineer]
    window.classcolors[GameLib.CodeEnumClass.Engineer]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.classcolors[GameLib.CodeEnumClass.Esper] = window.base:FindChild("TabWindow3:EsperColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Esper]
    window.classcolors[GameLib.CodeEnumClass.Esper]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.classcolors[GameLib.CodeEnumClass.Medic] = window.base:FindChild("TabWindow3:MedicColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Medic]
    window.classcolors[GameLib.CodeEnumClass.Medic]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.classcolors[GameLib.CodeEnumClass.Stalker] = window.base:FindChild("TabWindow3:StalkerColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Stalker]
    window.classcolors[GameLib.CodeEnumClass.Stalker]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.classcolors[GameLib.CodeEnumClass.Spellslinger] = window.base:FindChild("TabWindow3:SpellslingerColorPicker:Color")
    tmp_color = O.settings.classColors[GameLib.CodeEnumClass.Spellslinger]
    window.classcolors[GameLib.CodeEnumClass.Spellslinger]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors = {}
    window.abilitycolors[GameLib.CodeEnumDamageType.Magic] = window.base:FindChild("TabWindow3:MagicColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Magic]
    window.abilitycolors[GameLib.CodeEnumDamageType.Magic]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.Tech] = window.base:FindChild("TabWindow3:TechColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Tech]
    window.abilitycolors[GameLib.CodeEnumDamageType.Tech]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.Physical] = window.base:FindChild("TabWindow3:PhysicalColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Physical]
    window.abilitycolors[GameLib.CodeEnumDamageType.Physical]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.HealShields] = window.base:FindChild("TabWindow3:HealShieldsColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.HealShields]
    window.abilitycolors[GameLib.CodeEnumDamageType.HealShields]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.Heal] = window.base:FindChild("TabWindow3:HealColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Heal]
    window.abilitycolors[GameLib.CodeEnumDamageType.Heal]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.Fall] = window.base:FindChild("TabWindow3:FallColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Fall]
    window.abilitycolors[GameLib.CodeEnumDamageType.Fall]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.abilitycolors[GameLib.CodeEnumDamageType.Suffocate] = window.base:FindChild("TabWindow3:SuffocateColorPicker:Color")
    tmp_color = O.settings.abilityTypeColors[GameLib.CodeEnumDamageType.Suffocate]
    window.abilitycolors[GameLib.CodeEnumDamageType.Suffocate]:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.totalcolor = window.base:FindChild("TabWindow3:TotalColorPicker:Color")
    tmp_color = O.settings.totalColor
    window.totalcolor:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.defaultcolor = window.base:FindChild("TabWindow3:DefaultColorPicker:Color")
    window.defaulttext = window.base:FindChild("TabWindow3:DefaultText")
    window.defaulttext:SetText("Default")
    tmp_color = O.settings.defaultColor
    window.defaultcolor:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.textcolor = window.base:FindChild("TabWindow3:TextColorPicker:Color")
    window.texttext = window.base:FindChild("TabWindow3:TextText")
    window.texttext:SetText("Text")
    tmp_color = O.settings.textColor
    window.textcolor:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

    window.bgcolor = window.base:FindChild("TabWindow3:BGColorPicker:Color")
    window.bgtext = window.base:FindChild("TabWindow3:BGText")
    window.bgtext:SetText("BG")
    tmp_color = O.settings.backgroundColor
    window.bgcolor:SetBGColor( ApolloColor.new( tmp_color[1], tmp_color[2], tmp_color[3], tmp_color[4] ) )

  end
  
  window.lockbutton:SetCheck(O.settings.lock)
  window.tooltipsbutton:SetCheck(O.settings.tooltips)
  window.selfbutton:SetCheck(O.settings.alwaysShowPlayer)
  window.onlybossbutton:SetCheck(O.settings.showOnlyBoss)
  window.showfootercurrentbutton:SetCheck(O.settings.showFooterCurrent)
  window.showfooteroverallbutton:SetCheck(O.settings.showFooterOverall)
  window.showseparatepetsbutton:SetCheck(O.settings.showSeparatePets)
  window.hideduringcombatbutton:SetCheck(O.settings.hide_during_combat)
  window.showgatheringnodesbutton:SetCheck(O.settings.show_gathering_nodes)

  window.percentbutton:SetCheck(O.settings.showPercent)
  window.absbutton:SetCheck(O.settings.showAbsolute)
  window.rankbutton:SetCheck(O.settings.showRankNumber)
  window.shortbutton:SetCheck(O.settings.showShortNumber)
  window.showbattletotalbutton:SetCheck(O.settings.showBattleTotal)
  --window.showhistorytotalbutton:SetCheck(O.settings.showHistoryTotal)

  window.base:Show(not window.visible)
  window.visible = not window.visible  
end

function O:OnConfigTabEnter(wndHandler, wndControl, x, y)
  if wndControl ~= O.configWindow.tabs[O.configWindow.currenttab] then
    wndControl:SetOpacity(0.6)      
  end
end

function O:OnConfigTabExit(wndHandler, wndControl, x, y)
  if wndControl ~= O.configWindow.tabs[O.configWindow.currenttab] then
    wndControl:SetOpacity(0.2)      
  end
end

function O:OnConfigButtonClose(wndHandler, wndControl, eMouseButton)
  self.configWindow.base:Show(false)
  self.configWindow.visible = false
end

function O:OnConfigTabPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  for i = 1, #self.configWindow.tabs do
    if self.configWindow.tabs[i] == wndControl and i ~= self.configWindow.currenttab then
      for i = 1, #self.configWindow.tabs do
        self.configWindow.tabs[i]:SetOpacity(0.2)
        self.configWindow.tabwindows[i]:Show(false)
      end
      
      self.configWindow.currenttab = i
      self.configWindow.tabwindows[self.configWindow.currenttab]:Show(true)
      self.configWindow.tabs[O.configWindow.currenttab]:SetOpacity(0.9)
      
      break
    end
  end
end

function O:OnConfigHeaderButtonDown(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  local window = self.configWindow

  if eMouseButton == 0 then
    window.pressed = true
    local mouse = Apollo.GetMouse()
    window.mouseStartX = mouse.x
    window.mouseStartY = mouse.y
    
    local anchor = {window.base:GetAnchorOffsets()}
    window.attrStartX = anchor[1]
    window.attrStartY = anchor[2]
  end
end

function O:OnConfigHeaderButtonUp(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  local window = self.configWindow

  if eMouseButton == 0 then
    window.pressed = false
  end
end

function O:OnConfigHeaderMouseMove(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  local window = self.configWindow
  
  if window.pressed then
    local mouse = Apollo.GetMouse()
    local x = mouse.x - window.mouseStartX + window.attrStartX
    local y = mouse.y - window.mouseStartY + window.attrStartY
    
    local anchor = {window.base:GetAnchorOffsets()}
    window.base:SetAnchorOffsets(x, y, x + anchor[3] - anchor[1], y + anchor[4] - anchor[2])
  end
end

function O:OnConfigClassColorEnter(wndHandler, wndControl, x, y)
  if wndControl == wndHandler then
    wndControl:SetOpacity(0.7)      
  end
end

function O:OnConfigClassColorExit(wndHandler, wndControl, x, y)
  if wndControl == wndHandler then
    wndControl:SetOpacity(1)      
  end
end

function O:OnConfigClassColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  for key, frame in pairs(self.configWindow.classcolors) do
    if wndControl == frame then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.classColors[key] = { color.r, color.g, color.b, 1 }
        else
          self.settings.classColors[key] = color
        end
        wndControl:SetBGColor(color)
        self.Windows[1]:update()
      end)
    end
  end
end

function O:OnConfigAbilityColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
  for key, frame in pairs(self.configWindow.abilitycolors) do
    if wndControl == frame then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.abilityTypeColors[key] = { color.r, color.g, color.b, 1 }
        else
          self.settings.abilityTypeColors[key] = color
        end
        wndControl:SetBGColor(color)
        self.Windows[1]:update()
      end)
    end
  end
end

function O:OnConfigDefaultColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
    if wndControl == self.configWindow.defaultcolor then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.defaultColor = { color.r, color.g, color.b, 1 }
        else
          self.settings.defaultColor = color
        end
        wndControl:SetBGColor(color)
        self.Windows[1]:update()
      end)
    end
end

function O:OnConfigTextColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
    if wndControl == self.configWindow.textcolor then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.textColor = { color.r, color.g, color.b, 1 }
        else
          self.settings.textColor = color
        end
        wndControl:SetBGColor(color)
        self.Windows[1].frames.headerLabel:SetTextColor(self.settings.textColor)
        self.Windows[1].frames.timerLabel:SetTextColor(self.settings.textColor)
        self.Windows[1].frames.globalStatLabel:SetTextColor(self.settings.textColor)
        self.Windows[1]:update()
      end)
    end
end

function O:OnConfigTotalColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
    if wndControl == self.configWindow.totalcolor then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.totalColor = { color.r, color.g, color.b, 1 }
        else
          self.settings.totalColor = color
        end
        wndControl:SetBGColor(color)
        self.Windows[1]:update()
      end)
    end
end

function O:OnConfigBGColorPress(wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY)
    if wndControl == self.configWindow.bgcolor then
      local oldColor = wndControl:GetBGColor()
      self.DaiColorPicker.AdjustColor( oldColor, function(color, bIsFinal)
        if bIsFinal then return end
        if type(color) == "userdata" then
          self.settings.backgroundColor = { color.r, color.g, color.b, 1 }
        else
          self.settings.backgroundColor = color
        end
        wndControl:SetBGColor(color)

        self.Windows[1].frames.opacitybackground:SetBGColor(self.settings.backgroundColor)
        self.Windows[1].frames.copyBackground:SetBGColor(self.settings.backgroundColor)
        self.Windows[1].frames.header:SetBGColor(self.settings.backgroundColor)
        self.Windows[1].frames.footer:SetBGColor(self.settings.backgroundColor)

        self.configWindow.header:SetBGColor(self.settings.backgroundColor)
        self.configWindow.opacity:SetBGColor(self.settings.backgroundColor)

        for i = 1, #self.configWindow.tabs do
          self.configWindow.tabs[i]:SetBGColor(self.settings.backgroundColor)
        end

        self.Windows[1]:update()
      end)
    end
end

function O:OnConfigLockButton(wndHandler, wndControl, eMouseButton)
  self.settings.lock = not self.settings.lock
  self.UI.ShowResizer(not self.settings.lock)
end

function O:OnConfigTooltipsButton(wndHandler, wndControl, eMouseButton)
  self.settings.tooltips = not self.settings.tooltips
end

function O:OnConfigSelfButton(wndHandler, wndControl, eMouseButton)
  self.settings.alwaysShowPlayer = not self.settings.alwaysShowPlayer
end

function O:OnConfigOnlyBossButton(wndHandler, wndControl, eMouseButton)
  self.settings.showOnlyBoss = not self.settings.showOnlyBoss
end

function O:OnConfigPercentButton(wndHandler, wndControl, eMouseButton)
  self.settings.showPercent = not self.settings.showPercent
end

function O:OnConfigAbsButton(wndHandler, wndControl, eMouseButton)
  self.settings.showAbsolute = not self.settings.showAbsolute
end

function O:OnConfigRankButton(wndHandler, wndControl, eMouseButton)
  self.settings.showRankNumber = not self.settings.showRankNumber
end

function O:OnConfigShortButton(wndHandler, wndControl, eMouseButton)
  self.settings.showShortNumber = not self.settings.showShortNumber
end

function O:OnBGOpacitySliderChanged(wndHandler, wndControl, fNewValue, fOldValue)
  self.configWindow.bg_opacitytext:SetText(fNewValue / 10)
  self.settings.bg_opacity = fNewValue / 10

  self.Windows[1].frames.header:SetOpacity(self.settings.bg_opacity)
  self.Windows[1].frames.footer:SetOpacity(self.settings.bg_opacity)

end

function O:OnMGOpacitySliderChanged(wndHandler, wndControl, fNewValue, fOldValue)
  self.configWindow.mg_opacitytext:SetText(fNewValue / 10)
  self.settings.mg_opacity = fNewValue / 10

  self.Windows[1].frames.copyBackground:SetOpacity(self.settings.mg_opacity)
  self.Windows[1].frames.opacitybackground:SetOpacity(self.settings.mg_opacity)
  --for i = 1, #self.Windows[1].frames.rows do
  --  self.Windows[1].frames.rows[i].background:SetOpacity(self.settings.mg_opacity)
  --end

end

function O:OnBarOpacitySliderChanged(wndHandler, wndControl, fNewValue, fOldValue)
  self.configWindow.bar_opacitytext:SetText(fNewValue / 10)
  self.settings.bar_opacity = fNewValue / 10

  self.Windows[1].frames.rowbackground:SetOpacity(self.settings.fg_opacity)
  --self.Windows[1].frames.opacitybackground:SetOpacity(self.settings.mg_opacity)
  for i = 1, #self.Windows[1].frames.rows do
    self.Windows[1].frames.rows[i].background:SetOpacity(self.settings.bar_opacity)
  end

end

function O:OnFGOpacitySliderChanged(wndHandler, wndControl, fNewValue, fOldValue)
  self.configWindow.fg_opacitytext:SetText(fNewValue / 10)
  self.settings.fg_opacity = fNewValue / 10

  self.Windows[1].frames.background:SetOpacity(self.settings.fg_opacity)
  self.Windows[1].frames.headerLabel:SetOpacity(self.settings.fg_opacity)
  self.Windows[1].frames.timerLabel:SetOpacity(self.settings.fg_opacity)
  self.Windows[1].frames.globalStatLabel:SetOpacity(self.settings.fg_opacity)
end

function O:OnConfigShowPerBattleTotalButton(wndHandler, wndControl, eMouseButton)
  self.settings.showBattleTotal = not self.settings.showBattleTotal
  self.Windows[1]:update()
end

function O:OnConfigShowHistoryTotalButton(wndHandler, wndControl, eMouseButton)
  self.settings.showHistoryTotal = not self.settings.showHistoryTotal
  self.Windows[1]:update()
end

function O:OnConfigShowFooterCurrentTotalButton(wndHandler, wndControl, eMouseButton)
  self.settings.showFooterCurrent = not self.settings.showFooterCurrent
  self.Windows[1]:update()
end

function O:OnConfigShowFooterOverallTotalButton(wndHandler, wndControl, eMouseButton)
  self.settings.showFooterOverall = not self.settings.showFooterOverall
  self.Windows[1]:update()
end

function O:OnConfigShowSeparatePetsButton(wndHandler, wndControl, eMouseButton)
  self.settings.showSeparatePets = not self.settings.showSeparatePets
  self.Windows[1]:update()
end

function O:OnConfigHideDuringCombatButton(wndHandler, wndControl, eMouseButton)
  self.settings.hide_during_combat = not self.settings.hide_during_combat
  self.Windows[1]:update()
end

function O:OnConfigShowGatheringNodesButton(wndHandler, wndControl, eMouseButton)
  self.settings.show_gathering_nodes = not self.settings.show_gathering_nodes
  self.Windows[1]:update()
end

function O:OnEndCombatDelaySliderChanged(wndHandler, wndControl, fNewValue, fOldValue)
  self.configWindow.endcombatdelaytext:SetText(fNewValue)
  self.settings.combat_timeout = fNewValue
end